//+------------------------------------------------------------------+
//|                                                   EquLevelsT.mq4 |
//|                                                    Candid, 2010. |
//|                                          http://candid.110mb.com |
//+------------------------------------------------------------------+
//         .
//       .
string ScriptName = "EquLevels";

#property show_inputs

extern int N = 17;  //   
extern color LvlColor = Blue;  
extern string LvlPrefix = "EquLvl";

double LvlPrice[];
double LvlPrePrice[];
double LvlBase;
double LvlDist;

int CurY;
string SwPart1Name;
string SwPart2Name;

//+------------------------------------------------------------------+
void SetWingdingsLabel(string LabelName, string Code, int Corner, int X, int Y, color Color, int Size) {
  ObjectCreate(LabelName,OBJ_LABEL,0,0,0);
  ObjectSet(LabelName,OBJPROP_CORNER,Corner);
  ObjectSet(LabelName,OBJPROP_XDISTANCE,X);
  ObjectSet(LabelName,OBJPROP_YDISTANCE,Y);
  ObjectSetText(LabelName,Code,Size,"Wingdings",Color); 
  return;
}
//+------------------------------------------------------------------+
int init() {
  ArrayResize(LvlPrice,N);
  ArrayResize(LvlPrePrice,N);
    
  CurY = 10;
  SwPart1Name = ScriptName + "SwPart1";
  SetWingdingsLabel(SwPart1Name,"\xA4",1,10,30,Red,16);
  SwPart2Name = ScriptName + "SwPart2";
  SetWingdingsLabel(SwPart2Name,"\x48",1,14,CurY,Red,16);
  return (0);
}
//+------------------------------------------------------------------+
int deinit() {
  ObjectDelete(SwPart1Name);
  while (ObjectFind(SwPart2Name) >= 0) ObjectDelete(SwPart2Name);
  WindowRedraw();
  return (0);
}
//+------------------------------------------------------------------+
//| script                                                           |
//+------------------------------------------------------------------+
int start() {
  if (N < 2) return(0);
  int i;
  int N1 = N-1;
  int N2 = N/2;
  string LvlName;
  double PriceMax = 0.0;
  double PriceMin = 1.7976931348623158*MathExp(308);
  int LeftBar = WindowFirstVisibleBar();
  int RightBar = LeftBar-WindowBarsPerChart();
  if (RightBar < 0) RightBar = 0;
//  Comment("LeftBar=",LeftBar,", LeftPrice=",DoubleToStr(Close[LeftBar],Digits),", RightBar=",RightBar,", RightPrice=",DoubleToStr(Close[RightBar],Digits));
  for (i=RightBar;i<=LeftBar;i++) {
    if (PriceMax < High[i]) PriceMax = High[i];
    if (PriceMin > Low[i]) PriceMin = Low[i];
  }
//  LvlBase = (PriceMax+PriceMin)*0.5;
  LvlBase = PriceMax;
//  LvlBase = PriceMin;
  LvlDist = (PriceMax-PriceMin)/(N-1);
  for (i=0;i<N;i++) {
    LvlName = LvlPrefix + i; 
//    LvlPrice[i] = LvlBase+(i-N2)*LvlDist;
    LvlPrice[i] = LvlBase-i*LvlDist;
    LvlPrePrice[i] = LvlPrice[i];
    if (ObjectFind(LvlName) < 0) ObjectCreate(LvlName,OBJ_HLINE,0,0,LvlPrice[i]);
    else ObjectSet(LvlName,OBJPROP_PRICE1,LvlPrice[i]);
    ObjectSet(LvlName,OBJPROP_COLOR,LvlColor);
    if (i==0 || i == N2 || i == N1) ObjectSet(LvlName,OBJPROP_WIDTH,2);
  }
  WindowRedraw();

  while (CurY == 10) {
    bool RedrawLvls = false;
    for (i=0;i<N;i++) {
      LvlName = LvlPrefix + i; 
      LvlPrePrice[i] = LvlPrice[i];
      LvlPrice[i] = ObjectGet(LvlName,OBJPROP_PRICE1);
      if (LvlPrePrice[i] != LvlPrice[i]) {
        RedrawLvls = true;
        if (i == 0 || i == N2 || i == N1) LvlBase += LvlPrice[i]-LvlPrePrice[i];
        else LvlDist = (LvlBase-LvlPrice[i])/i;
//        else LvlDist = (LvlPrice[i]-LvlBase)/i;
//        else LvlDist = (LvlPrice[i]-LvlBase)/(i-N2);
        break;
      }
    }  //  for (i=0;i<N;i++)
    if (RedrawLvls) {
      for (i=0;i<N;i++) {
        LvlName = LvlPrefix + i; 
//        LvlPrice[i] = LvlBase+(i-N2)*LvlDist;
//        LvlPrice[i] = LvlBase+i*LvlDist;
        LvlPrice[i] = LvlBase-i*LvlDist;
        LvlPrePrice[i] = LvlPrice[i];
        ObjectSet(LvlName,OBJPROP_PRICE1,LvlPrice[i]);
      }
      WindowRedraw();
    }  //  if (RedrawLvls)

    Sleep(100);
    CurY = ObjectGet(SwPart2Name,OBJPROP_YDISTANCE);
  }  //  while (CurY == 10)

  Sleep(500);
  return (0);
}  